Package org.optaplanner.core.impl.solver.termination

## Class AndCompositeTermination<Solution_>

- java.lang.Object
- - org.optaplanner.core.impl.solver.event.SolverLifecycleListenerAdapter<Solution_>
  - - org.optaplanner.core.impl.phase.event.PhaseLifecycleListenerAdapter<Solution_>
    - - org.optaplanner.core.impl.solver.termination.AbstractTermination<Solution_>
      - - org.optaplanner.core.impl.solver.termination.AbstractCompositeTermination<Solution_>
        - - org.optaplanner.core.impl.solver.termination.AndCompositeTermination<Solution_>

- All Implemented Interfaces:
    `EventListener`, `PhaseLifecycleListener<Solution_>`, `SolverLifecycleListener<Solution_>`, `Termination<Solution_>`

      public class AndCompositeTermination<Solution_>
      extends AbstractCompositeTermination<Solution_>

- - ### Field Summary

    - ### Fields inherited from class org.optaplanner.core.impl.solver.termination.AbstractCompositeTermination

      `terminationList`

    - ### Fields inherited from class org.optaplanner.core.impl.solver.termination.AbstractTermination

      `logger`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `AndCompositeTermination​(List<Termination<Solution_>> terminationList)` |
    `AndCompositeTermination​(Termination<Solution_>... terminations)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `double` | `calculatePhaseTimeGradient​(AbstractPhaseScope<Solution_> phaseScope)` | Calculates the minimum timeGradient of all Terminations.
    `double` | `calculateSolverTimeGradient​(SolverScope<Solution_> solverScope)` | Calculates the minimum timeGradient of all Terminations.
    `AndCompositeTermination<Solution_>` | `createChildThreadTermination​(SolverScope<Solution_> solverScope, ChildThreadType childThreadType)` | Create a `Termination` for a child `Thread` of the `Solver`.
    `boolean` | `isPhaseTerminated​(AbstractPhaseScope<Solution_> phaseScope)` | Called by the `Phase` after every step and every move to determine if the search should stop.
    `boolean` | `isSolverTerminated​(SolverScope<Solution_> solverScope)` | Called by the `Solver` after every phase to determine if the search should stop.
    `String` | `toString()` |

    - ### Methods inherited from class org.optaplanner.core.impl.solver.termination.AbstractCompositeTermination

      `createChildThreadTerminationList, phaseEnded, phaseStarted, solvingEnded, solvingStarted, stepEnded, stepStarted`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### AndCompositeTermination

          public AndCompositeTermination​(List<Termination<Solution_>> terminationList)

    - #### AndCompositeTermination

          public AndCompositeTermination​(Termination<Solution_>... terminations)

  - ### Method Detail

    - #### isSolverTerminated

          public boolean isSolverTerminated​(SolverScope<Solution_> solverScope)

      Description copied from interface: `Termination`
      Called by the `Solver` after every phase to determine if the search should stop.
      Parameters:
        `solverScope` - never null
      Returns:
        true if all the Terminations are terminated.

    - #### isPhaseTerminated

          public boolean isPhaseTerminated​(AbstractPhaseScope<Solution_> phaseScope)

      Description copied from interface: `Termination`
      Called by the `Phase` after every step and every move to determine if the search should stop.
      Parameters:
        `phaseScope` - never null
      Returns:
        true if all the Terminations are terminated.

    - #### calculateSolverTimeGradient

          public double calculateSolverTimeGradient​(SolverScope<Solution_> solverScope)

      Calculates the minimum timeGradient of all Terminations. Not supported timeGradients (-1.0) are ignored.
      Parameters:
        `solverScope` - never null
      Returns:
        the minimum timeGradient of the Terminations.

    - #### calculatePhaseTimeGradient

          public double calculatePhaseTimeGradient​(AbstractPhaseScope<Solution_> phaseScope)

      Calculates the minimum timeGradient of all Terminations. Not supported timeGradients (-1.0) are ignored.
      Parameters:
        `phaseScope` - never null
      Returns:
        the minimum timeGradient of the Terminations.

    - #### createChildThreadTermination

          public AndCompositeTermination<Solution_> createChildThreadTermination​(SolverScope<Solution_> solverScope,
                                                                                 ChildThreadType childThreadType)

      Description copied from interface: `Termination`
      Create a `Termination` for a child `Thread` of the `Solver`.
      Specified by:
        `createChildThreadTermination` in interface `Termination<Solution_>`
      Overrides:
        `createChildThreadTermination` in class `AbstractTermination<Solution_>`
      Parameters:
        `solverScope` - never null
        `childThreadType` - never null
      Returns:
        not null

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`